<template>
  <v-dialog :value="value" @input="$emit('input')" scrollable max-width="700px" persistent>
    <v-card>
      <v-card-text>
        <v-stepper v-model="e1" alt-labels>
          <template>
            <v-stepper-header>
              <template v-for="(n,index) in steps">
                <v-stepper-step :key="`${index+1}-step`" :complete="e1 > index+1" :step="index+1">
                  <span class="text-center">{{ n }}</span>
                </v-stepper-step>
                <v-divider v-if="index+1 !== steps.length" :key="index+1"></v-divider>
              </template>
            </v-stepper-header>
            <v-stepper-items>
              <v-stepper-content
                v-for="(n,index) in steps"
                :key="`${index+1}-content`"
                :step="index+1"
              >
                <div class="content-header" v-if="index > 0">
                  <v-btn x-small @click="goBack(index+1)" text class="btnback">
                    <i class="fas fa-chevron-left"></i> Regresar
                  </v-btn>
                </div>
                <div v-if="index+1 == 1">
                  <st-first-step
                    :data="data"
                    @next="nextStep(index+1, $event)"
                    @cancel="$emit('input')"
                  />
                </div>
                <div v-if="index+1 == 2">
                  <st-second-step
                    ref="second"
                    :data="data"
                    @next="nextStep(index+1, $event)"
                    @cancel="$emit('input')"
                  />
                </div>
              </v-stepper-content>
            </v-stepper-items>
          </template>
        </v-stepper>
      </v-card-text>
    </v-card>
  </v-dialog>
</template>

<script>
import FirstStep from "@/components/tutorship/UpdateFirstStep.vue";
import SecondStep from "@/components/tutorship/UpdateSecondStep.vue";

export default {
  props: {
    value: Boolean,
    data: Object
  },
  data() {
    return {
      tutorship: {},
      e1: 1,
      steps: ["Actualizar datos generales", "Actualizar características"]
    };
  },
  components: {
    "st-first-step": FirstStep,
    "st-second-step": SecondStep
  },
  methods: {
    goBack(n) {
      this.e1 = n - 1;
    },
    nextStep(n, data) {
      this.tutorship[`data${n}`] = data;
      if (n === this.steps.length) {
        let { data1, data2, data3, data4 } = this.tutorship;
        let tutorship = { ...data1, ...data3, ...data4, ...data2 };
        let post = {
          idUnidad: this.$store.state.role.idUnit,
          tutoria: tutorship
        };
        let post2 = {
          idTutoria: this.$route.params.id,
          nombre: post.tutoria.nombre,
          descripcion: post.tutoria.descripcion,
          numeroSesiones: post.tutoria.numeroSesiones,
          caracteristicas:{
            esObligatoria: !post.tutoria.caracteristicas.esObligatoria,
            esIndividual : post.tutoria.caracteristicas.esIndividual,
            esTutorAsignado : !post.tutoria.caracteristicas.esTutorAsignado,
            esTutorFijo : post.tutoria.caracteristicas.esTutorFijo
          }
        };
        
        this.register(post2)
      } else {
        this.e1 = n + 1;
      }
    },
    async register(data) {
      try {
        let response = await this.$api.updateTutorship(this.$route.params.id, data);
        this.$emit("refreshData", { response: response });
        // this.$router.push("/coordinador/tutorias")
      } catch (e) {
        this.$store.commit("setError", e);
      }
    
    }
  }
};
</script>
<style scoped lang="scss">
/* scope for encapsulate css */
.v-card__text {
  padding: 0 !important;
}
</style>
